/* ѴץऽΣ
** ţգäʣɣӤؤѴ
** Usage: utoj FILENAME        */

#include <stdio.h>

#define ASCII 0
#define KANJI 1

void error(int i) {
        fprintf(stderr, "Error Code = %d\n", i);
        fprintf(stderr, "Usage: jtos [input filename [output filename]]\n");
        exit(i);
}

void main(argc, argv) int argc; char *argv[]; {

	FILE *in, *out;
	char status = ASCII;
	int i, j;

        fprintf(stderr, "KANJI CONVERSION EUC to JIS Ver. 2.0\n");
        fprintf(stderr, "Usage: %s [input [output]]\n", argv[0]);
        switch(argc) {
                case 1:
                        in = stdin;
                        out = stdout;
                        break;
                case 2:
                        out = stdout;
                        if((in = fopen(argv[1], "rb")) == NULL) error(1);
                        break;
                case 3:
                        if((in = fopen(argv[1], "rb")) == NULL) error(2);
                        if((out = fopen(argv[2], "wb")) == NULL) error(3);
                        break;
                default:
                        error(4);
                        break;
        }
	while((i = fgetc(in)) != EOF) {
		if(i <= 0x7f) {
			if(status == KANJI) {
				status = ASCII;
				fputc(0x1b, out);
				fputc(0x28, out);
				fputc(0x4a, out);
			}
			fputc(i, out);
		} else {
			if(status == ASCII) {
				status = KANJI;
				fputc(0x1b, out);
				fputc(0x24, out);
				fputc(0x40, out);
			}
			j = fgetc(in);
			i -= 0x80;
			j -= 0x80;
			fputc(i, out);
			fputc(j, out);
		}
	}
	if(status == KANJI) {
		fputc(0x1b, out);
		fputc(0x28, out);
		fputc(0x4a, out);
	}
	fclose(in);
	fclose(out);
	fprintf(stderr, "CONVERSION COMPLETE\n");
}



